#!/bin/bash
#echo "argc = ${#*}"
#echo "argv = ${*}"
echo "Args: $@"
#env
echo "This is my simple AWS job!."

echo "secret key: $AWS_SECRET_ACCESS_KEY"
echo "access key secret: $AWS_ACCESS_KEY_ID"
echo "S3 bucket Name: $S3_BUCKET_NAME"


if [ $AWS_ACCESS_KEY_ID == 'test' ]
then
echo Missing AWS ACCESS KEY.
exit
elif [ $AWS_SECRET_ACCESS_KEY == 'test' ]
then
echo Missing AWS SECRET ACCESS KEY.
exit
elif [ $S3_BUCKET_NAME == 'test' ]
then
echo Missing S3 Bucket Name.
exit
else
echo All good.
fi


#configure AWS CLI
aws configure set aws_access_key_id "$AWS_ACCESS_KEY_ID" --profile default
aws configure set aws_secret_access_key "$AWS_SECRET_ACCESS_KEY" --profile default
aws configure set region "ap-southeast-1" --profile default
aws configure set output "json" --profile default

#Initialize Terraform
terraform init

#Execute Terraformer for all Region

terraformer import aws --resources="*" --excludes=iam,sns --regions=ap-southeast-1 --retry-number=10
terraformer import aws --resources="*" --excludes=iam,sns --regions=ap-southeast-1 --path-pattern=combined --retry-number=10
#terraformer import aws --resources="*" --retry-number=10
#terraformer import aws --resources="*" --path-pattern=combined --retry-number=10
#--profile=defaults

cd combined
cp -r /.terraform .
terraform init
driftctl scan  > driftctl.json
#debug purpose
cd ..
pwd
ls -d */
cd generated/aws
printf "test start"

#--
for f in *; do
    if [ -d "$f" ]; then
        # Will not run if no directories are available
        cd $f
       
        if [ -d "ap-southeast-1" ]; then
            # Will enter here if $DIRECTORY exists, even if it contains spaces
            cd ap-southeast-1
            echo "found folder with ap-southeast-1"
            export region_in_folder=true
		else
		    export region_in_folder=false
        fi
        echo "$f"
        ls -a
        filesCount=$(find . -type f | wc -l) #Count files and store in a variable
        if (( filesCount >= 4 ));
        then
            echo "More than 4 archives found!"
            cp -r /.terraform .
            terraform init
            terraform plan -out tf.plan
            terraform show -json tf.plan  > tf.json
            checkov -f tf.json  > checkov.html
            rm -rf .terraform
            if [ $region_in_folder == true ] ; then
              cd ..
              echo "cd back to previous folder"
              ls -a
            fi

            cd ..
        else
            cd ..
            echo "check why less than 4 and remove the folder"
            rm -rf $f
        fi
        echo "end!"
    fi
done
printf "test end"
cp -r /combined/driftctl.json .
cd ..



DATE=$(date '+%Y-%m-%d:%H:%M:%s')
BUCKET="$S3_BUCKET_NAME"
#"dev-terraform-environment"
aws s3 cp --recursive "aws" s3://${BUCKET}/${DATE}
#echo aws s3 cp aws s3://<S3_BUCKET_NAME>/$DATE/ --recursive

echo "Done S3 upload!${BUCKET} ${DATE}"
#cd generated/aws/iam

#cp -r /.terraform .


#terraform init
#terraform plan -out tf.plan
#terraform show -json tf.plan  > tf.json
#checkov -f tf.json  > checkov.json

#debug purpose
#----------------------
ls -a

AWS_ACCESS_KEY_ID=$1
AWS_SECRET_ACCESS_KEY=$2
S3_BUCKET_NAME=$3
printf "==>[process.sh] %s\n" "entry_point_param is $AWS_ACCESS_KEY_ID"

PARAM1=$(echo $AWS_ACCESS_KEY_ID | cut -d':' -f1) # output is 1 must be 'bash' it     will be tested
PARAM2=$(echo $AWS_SECRET_ACCESS_KEY | cut -d':' -f2) # the real command separated by     &&
PARAM2=$(echo $S3_BUCKET_NAME | cut -d':' -f3) # the real command separated by     &&

printf "==>[process.sh] %s\n" "PARAM1=$PARAM1"
printf "==>[process.sh] %s\n" "PARAM2=$PARAM2"

if [ "$PARAM1" = "bash" ];
then
    printf "==>[entrypoint.sh] %s\n" "about to running $PARAM2 command"
    echo $PARAM2 | tr '&&' '\n' | while read cmd; do
        $cmd
    done
fi
#----------------------
#debug end